/* vxconv.c
**
** Hauptprogramm zu `vxconv'.
**
** Aufgabe dieses Programmes ist es, vorhandene Standardfolder der SMTP-Server
** `smail', `sendmail', ... in das VxMail-Format zu konvertieren. Dazu mu
** lediglich eine Indexdatei zu dem jeweiligen Folder erzeugt werden, die die
** Anfangspositionen der einzelnen E-Mails innerhalb des zu konvertierenden
** Folders enthlt.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>

#include "config.h"
#include "prefs.h"
#include "conf.h"
#include "tools.h"
#include "vxerror.h"
#include "xfile.h"
#include "conv.h"
#include "version.h"
#include "vxopt.h"

void usage (void)
{
    fprintf (stderr, "\nUsage: %s [-f <configfile>] <folderfile> ..."
		     "\n       %s -h"
		     "\n       %s -V\n"
		     "\n   -f <configfile>"
		     "\n       read configuration from file <configfile>"
		     "\n       (default: %s)"
		     "\n   -h"
		     "\n       show this help"
		     "\n   -V"
		     "\n       show the program's version number\n\n",
		     progname, progname, progname, CONFIGFILE);
    exit (1);
}

int main (int argc, char *argv[])
{
    int ix;

    vxopt (&argc, argv, usage);
    if ((progname = strrchr(argv[0], '/'))) ++progname; else progname = argv[0];

    if (argc < 2) {
	fprintf (stderr, "%s: no folder file specified!\n", progname);
	exit (1);
    }
    /* Lies die Konfigurationsdatei ein. */
    getconf ();
    /* Initialisiere den Konverter. */
    conv_init ();
    /* Konvertiere jede angegebene Folderdatei. */
    for (ix = 1; ix < argc; ++ix) {
	xFile fx = xOpen (argv[ix], "ix", prefs.fperm);
	if (!fx) {
	    fprintf (stderr, "%s: opening folder `%s' failed",
			     progname,
			     argv[ix]);
	    perror ("");
	    continue;
	}
	conv (fx);
	xClose (fx);
    }
    return 0;
}
