.TH VxDeliver 8 
.\" NAME should be all caps, SECTION should be 1-8, maybe w/ subsection
.\" other parms are allowed: see man(7), man(1)
.SH NAME
vxdeliver \- deliver e-mails locally, identifying the recipient(s) by a user
database
.SH SYNOPSIS
.B vxdeliver
.I "[-f <conffile> | --config=<conffile>] <sender-addr> <recipient-addr> ..."
.br
.B vxdeliver
.I "{-h | --help}"
.SH "DESCRIPTION"
\fBvxdeliver\fP is the local delivery agent of the \fBVxMail\fP\-system; it
uses the \fI<recipient\-addr>\fP arguments as keys into a user database in order
to find the recipient folders.  This mechanism \- together with a complement
program, the POP3-server \fBvxpop\fP \- can be used for installing of more
than one e-mail domain on the same server. Because these e\-mail domains can be
non\-IP based, you could use the term \fIvirtual\fP e\-mail domains.
.br
\fBvxdeliver\fP uses a central configuration file which is shared by all
programs of the \fBVxMail\fP system; this configuration file holds the name of
the user database.
.br
\fBvxdeliver\fP should be inserted as a new mailer into the existing
configuration of your \fISTMP\fP\-server. Included into the source packages of
the \fBVxMail\fP\-system there are two examples describing a way how to do this
with the configurations of the widely known \fISMTP\fP\-servers \fBsendmail\fP
and \fPsmail\fP.
.SH OPTIONS
.TP
.B \-h, \-\-help
shows a short description how to use this program.
.TP
.B \-f <configfile>, \-\-config\=<configfile>
reads the configuration from the file \fI<configfile>\fP instead of
\fI%conffile%\fP.
.TP
.B "<sender-addr>"
The e\-mail address of the sender of the message.
.TP
.B "<recipient-addr> ..."
A list of recipient e\-mail addresses.
.SH "SEE ALSO"
.BR "vxcheck(8)"
.BR "vxconv(8)"
.BR "vxdeliver(8)"
.BR "vxdomcheck(8)"
.BR "vxdump(8)"
.BR "vxgetconf(8)"
.BR "vxmkdb(8)"
.BR "vxpop(8)"
.SH AUTHOR
Boris Jakubith <bj@cs.tu-berlin.de> (<fbj@avus.de>).
.br
\fB(c) 1998/1999, Boris Jakubith\fP
