/* userdb.h
**
**  Interface for module `db.c'
**  (Database functions for vxmail)
**
*/
#ifndef _DB_H
#define _DB_H

/* Ininitialize the user database */
void init_userdb (void);

/* check for the existance of an e-mail domain */
int domain_check (char *em_addr);

/* check for the existance of an e-mail (standard or non-standard) domain */
int xdomain_check (char *em_addr);

/* get_ffile (addr)
**     returns the name of a filter file for the domain, the user `addr' is
**     a member of - or NULL (if the domain doesn't have a filter).
*/
char *get_ffile (char *em_addr);

/* get a user's folder;
 * if the user entry is a link, then resolve this link first
 */
char *user_folder (char *em_addr, int *nonstd);

/* try to get a users folder after replacing the domain part of the
** e-mail address
*/
char *user_rewrite (char *em_addr, int *nonstd);

/* get the mail hostname from the database */
char *mailhost (void);

/* get the name of the defaultadministrator from the database */
char *defadmin (void);

#endif /* defined (_DB_H) */
