/* vxwrapper.c
**
** a small wrapper program for running `vxdeliver' with superuser permissions;
** this is required for `vxdeliver' to be fully operational because `vxdeliver'
** no longer can be executed `setuid root' (the ability to execute programs
** from it forbids `setuid root' permissions). Instead, this wrapper program
** should be set `setuid root' but restricted in it's execute permissions to
** to owner read/execution and group execution only (-r-s--x---).
** the path to `vxdeliver' is hard-coded in this wrapper program, which
** restricts it's use to executing `vxdeliver' only.
*/

#include <unistd.h>
#include <errno.h>

#include "vxerror.h"

int main (int argc, char *argv[], char **envp)
{
    setuid (geteuid ());
    setgid (0);
    argv[0] = BINDIR "/vxdeliver";
    execve (BINDIR "/vxdeliver", argv, envp);
    vxerror (EX_OSERR, errno, "i couldn't run `" BINDIR "/vxdeliver'");
    return 0;
}
