/* delete.h
**
** Interface file for `delete.c'
** (Delete operations for the different database entry types)
**
*/
#ifndef _DELETE_H
#define _DELETE_H

#include "ParserData.h"

/* Delete a user entry and all links pointing to it. */
int delete_user (ParserData *sd, char *username);

/* Delete a domain, all user entries in this domain and all links referring
** this domain or users in this domain.
*/
int delete_domain (ParserData *sd, char *domname);

/* delete an e-mail filter from a domain */
void delete_filter (ParserData *sd, char *domname);

void delete_special (ParserData *sd, char *iname, int rt);

#endif /* defined(_DELETE_H) */
