#ifndef _PROCS_H
#define _PROCS_H

#include "ParserData.h"

extern ParserData sd;

void yyinit (char *filename, int tabsize);

void yyclose (ParserData *sd);

extern void InitDB (ParserData *sd);

extern int new_domain (ParserData *sd);

extern int get_domain (ParserData *sd);

extern int ins_user (ParserData *sd, char *user, char *pass, int urt);

extern void ins_iptrans (ParserData *sd, char *iptag, char *domain, int isIPv6);

extern void ins_domlink (ParserData *sd, char *link, char *domain);

extern void ins_link (ParserData *sd, char *user, char *linkto);

extern void ins_alp (ParserData *sd, char *user, char *alp);

extern void ins_filter (ParserData *sd, char *filter);

extern void ins_mailadm (ParserData *sd, char *em_addr, char *folderpath);

extern void ins_redirect (ParserData *sd, char *domain, char *password,
			  char *targethost);

extern void ins_vxts (ParserData *sd, char *vxtspass);

extern void ccerror (ParserData *sd, char *fmt, ...);

extern void insert_domain (ParserData *sd);

extern int yylex (void);

extern void yyerror (char *message);

/* data checking functions */

extern int uncheck (ParserData *sd, char *uname, int adm);
extern int dncheck (ParserData *sd, char *dname);
extern int fdcheck (ParserData *sd, char *folderdir);
extern int fpcheck (ParserData *sd, char *folderpath);
extern int hncheck (ParserData *sd, char *hostname);
extern int macheck (ParserData *sd, char *maddr);

#define NEW_DOMAIN 2
#define OLD_DOMAIN 1

#endif /* defined(_PROCS_H) */
