#! /usr/bin/perl

sub usage ();
sub pnpath ($);
sub which ($);

($progname, $progpath) = pnpath ($0);

#$dbtool = which ('vxmkdb');
$dbtool = '/home/bj/src/C/VxMail/VxMail-1.39/VxMkDB/vxmkdb' unless $dbtool;
unless (-f $dbtool and -x $dbtool) {
    die "$progname: Sorry, but `VxMail' seems not be installed on ",
	"this system!\n";
}

if (@ARGV < 1) { usage (); }

$USERS = shift @ARGV;
$DOMAIN = (@ARGV ? (shift @ARGV) : "blinx.de");

# Read the users from the input file
open USERS, "<$USERS" or die "$progname($USERS): $!\n";
%USERS = ();
while (<USERS>) {
    chomp;
    ($name, $pass, $flag) = split /#/, $_;
    $USERS{$name} = $pass;
}
close USERS;

($Y, $M, $D) = (localtime)[5, 4, 3];
$date = sprintf "%04d%02d%02d", $Y+1900, $M, $D;

#unless (-d '/root/tmp') {
#    mkdir '/root/tmp', 0700 or die "$progname(mkdir /root/tmp): $!\n";
#}

# Try to connect to the database
open UDB, "|$dbtool -f test.conf" or
    die "$progname(vxmkdb): $!\n";

# Select the domain
print UDB "DOMAIN \"$DOMAIN\"\n";

# If this succeeded, insert the users into the database
for $USER (keys %USERS) {
    $PASS = $USERS{$USER};
    print UDB "USER \"$USER\" \"$PASS\"",
	      ($flag eq 'S' ? " INVALID" : ($flag eq 'A' ? " ADMIN" : "")),
	      "\n";
}

close UDB;

exit 0;

sub usage ()
{
    die "Usage: $progname userfile [domain]\n"
}

sub pnpath ($) {
    use Cwd;
    my @p = split '/', $_[0];
    my @w = split '/', (cwd ());
    my (@mix, @res, $x);
    my $pn = pop @p;
    @p = ('') unless @p;
    @w = () unless $p[0];
    @mix = (@w, @p); @res = ();
    while (@mix) {
	$x = shift @mix;
	if ($x eq '..') {
	    pop @res if (@res > 1);
	} elsif ($x ne '.') {
	    push @res, $x;
	}
    }
    ($pn, join ('/', @res))
}

sub which ($)
{
    my ($prog) = @_;
    my @PATH = split /:/, $ENV{PATH};
    my ($path, $pp);
    for $path (@PATH) {
	$pp = "$path/$prog";
	if (-x $pp and not (-d $pp or -c $pp or -b $pp)) { return $pp; }
    }
    return undef;
}
