.TH VxPOP 8 
.\" NAME should be all caps, SECTION should be 1-8, maybe w/ subsection
.\" other parms are allowed: see man(7), man(1)
.SH NAME
vxpop \- the POP3 server of the \fBVxMail\fP system.
.SH SYNOPSIS
.B vxpop
.I "[option ...]"
.br
.B vxpop
.I "{-h | --help}"
.SH "DESCRIPTION"
\fBvxpop\fP is the POP3 server of the \fIVxMail\fP system. It uses the same
user database as the local delivery agent \fBvxdeliver\fP for authentication
purposes. \fBvxpop\fP implements all standard POP3 commands and additionally
the optional \fBAPOP\fP and \fBTOP\fP commands. It can run as a standalone
server process or as a sub-server of an \fIinetd\fP\-like server process.
.br
As an additional feature, this POP3 server can handle redirects:
.br
.TP
.B " "
if a system administrator decides that an e-mail domain should be moved to
another host, he can insert a domain redirection into the database \- instead
of the original domain entry. If \fBvxpop\fP finds such an entry during the
user authentication process, it will contact the new POP3 server and transmit
the user commands to this server; it interprets the answers of the \fBSTAT\fP,
\fBLIST\fP, \fBTOP\fP and \fBRETR\fP commands and inserts an additional message
\- if it is configured for \- into the list of messages sent to the user. If
the user requests a transmission of this message, \fBvxpop\fP will send the
contents of a text file instead of transmitting this command to the new POP3
server.
.SH OPTIONS
.TP
.B \-h, \-\-help
shows a short information how to use this program.
.TP
.B \-d, \-\-nodetach
don't detach from the terminal; this option is interesting for debugging
purposes. If it is supplied, it forces the \fI\-s\fP (\fI\-\-server\fP)
option, too.
.TP
.B \-f <configfile>, \-\-config\=<configfile>
Read the configuration from the file \fB<configfile>\fP instead of the
default configuration file (\fI%conffile%\fP).
.TP
.B \-l <logfile>, \-\-log\=<logfile>
Redirect error and logging messages to the file \fB<logfile>\fP instead
of \fI/dev/null\fP; this option is overridden by the \fB\-d\fP
(\fB\-\-detach\fP) option which forces error and debug messages to be sent
to \fIstdout\fP instead.
.TP
.B \-p <portnum>, \-\-port\=<portnum>
wait on port \fB<portnum>\fP for clients instead of the default one.
The POP3\-port is normally read (by using the service name) from the
\fI/etc/services\fP file. Because the name for the POP3 service can differ
for different Linux\-distributions (e.g. \fIDebian\fP and \fIS.u.S.E.\fP),
it can be configured using the \fBservice\fP entry in the configuration file.
If neither the \fB\-p\fP (\fB\-\-portnum\fP) is specified nor a service name
is configured, \fBvxpop\fP uses the compiled default \fI%port%\fP instead.
.TP
.B \-s, \-\-server
start \fBvxpop\fP as a standalone server instead of as a sub\-server of an
\fIinetd\fP\-like server process. This option is forced by the \fB\-d\fP
(\fB\-\-detach\fP) option.
.TP
.B \-v, \-\-verbose
increases the LOG\-level; this option works only if either \fI\-d\fP
(\fI\-\-nodetach\fP) or \fI\-l\fP (\fI\-\-log\fP) was specified, too.
At the moment, the maximum LOG\-level which \fBvxpop\fP recognizes is 4.
.SH "SEE ALSO"
.BR "vxcheck(8)"
.BR "vxconv(8)"
.BR "vxdeliver(8)"
.BR "vxdomcheck(8)"
.BR "vxdump(8)"
.BR "vxgetconf(8)"
.BR "vxmkdb(8)"
.BR "vxpop(8)"
.SH AUTHOR
Boris Jakubith <bj@cs.tu-berlin.de> (<fbj@avus.de>).
.br
\fB(c) 1998/1999, Boris Jakubith\fP
