/* drac.c
**
** Support module for the `Dynamic Relay Authorization Control' server
** of Gary Mills <mills@cc.umanitoba.ca>
**
*/

#include "prefs.h"
#include "tools.h"
#include "hlsock.h"

/* I can suport DRAC only if the corresponding library module exists in the
** system and VxMail is configured for support; this is clarified by the
** Setup-script
*/

#ifdef DRAC_AUTH
extern int dracauth (char *server, unsigned long userip, char **errmsg);
#endif

void DRACsend (char *mailhost) {
#ifdef DRAC_AUTH
    char *err;
    if (prefs.dracauth) {
	if (dracauth(mailhost, LLPeeraddr (0), &err)) {
	    vxlog (1, "DRAC RELAY authentication failed:\n    %s\n", err);
	}
    }
#else
    ;
#endif
}
