/* sysauth.c
**
** try to authenticate a user with the system password database
** (/etc/passwd, /etc/shadow)
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <sys/types.h>
#include <pwd.h>

#ifndef NOSHADOW
#include <shadow.h>
#endif

#include "vxerror.h"
#include "dbif.h"
#include "tools.h"
#include "config.h"
#include "prefs.h"

dbif_rec *sysauth (dbif_rec *rec, char *em_addr)
{
    /* Was mu ich tun?
    ** Zuerst mu ich den Benutzernamen aus der E-Mailadresse extrahieren;
    ** Mit diesem mu ich dann in die /etc/passwd (bzw. /etc/shadow) gehen,
    ** um einen passenden Eintrag zu finden.
    ** Finde ich keinen passenden Eintrag, so mu ich einen leeren Benutzer-
    ** datensatz zurckgeben.
    ** Finde ich hingegen einen Datensatz, so mu ich herausfinden, wo mein
    ** E-Mailfolder eigentlich stehen soll; habe ich dies geklrt, dann mu
    ** ich einen Benutzerdatensatz knstlich erzeugen; dieser mu(!!!) ein
    ** gesetztes `nonstandard'-Flag enthalten!
    ** Bin ich damit fertig, dann ist der so erzeugte Datensatz das Ergebnis
    ** meiner Bemhungen.
    */
    struct passwd *pw;
    struct spwd *sp;
    char *user, *xp;
    size_t fll = strlen (rec->folder);
    dbif_rec *res = (dbif_rec *) 0;
    xp = strchr (em_addr, '@');
    user = galloc (__FILE__, __LINE__, xp - em_addr + 1);
    memcpy (user, em_addr, xp - em_addr);
    user[xp - em_addr] = '\0';
    xp = galloc (__FILE__, __LINE__, fll + (xp - em_addr) + 2);
    memcpy (xp, rec->folder, fll);
    if (xp[fll - 1] != '/') { xp[fll++] = '/'; }
    xp[fll] = '\0';
    strcat (xp, user);
    /* I must switch back to uid 0 in order to be able to read the file
    ** `/etc/shadow'
    */
    seteuid (getuid ());
    if (!(pw = getpwnam (user))) {
	gfree (xp);
	gfree (user);
	return res;
    }
#ifndef NOSHADOW
    if (!strcmp (pw->pw_passwd, "x") || !strcmp (pw->pw_passwd, "*")) {
	if (!(sp = getspnam (user))) {
	    gfree (xp);
	    gfree (user);
	    return res;
	}
	res = dbif_mkrec (sp->sp_pwdp, xp, RT_NSUSER);
	seteuid (pw->pw_uid);
	setgid (pw->pw_gid);
	gfree (xp);
	gfree (user);
	return res;
    }
#endif
    res = dbif_mkrec (pw->pw_passwd, xp, RT_NSUSER);
    seteuid (pw->pw_uid);
    setgid (pw->pw_gid);
    gfree (xp);
    gfree (user);
    return res;
}
