/* popmsg.c
**
** write POP3 messages
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <stdarg.h>

#include "config.h"
#include "tools.h"

#define _POPMSG_C
#include "popmsg.h"

void pop_msg (int msgcode, char *fmt, ...)
{
    va_list ap;
    va_start (ap, fmt);
    alarm (VXPOP_SENDTIMEOUT);
    printf (msgcode == ERR ? "-ERR " : (msgcode == OK ? "+OK " : ""));
    vfprintf (stdout, fmt, ap);
    if (msgcode != NOEOL) fprintf (stdout, "\r\n");
    fflush (stdout);
    alarm (0);
}

void pop_sstrg (char *string, int byte_stuff)
{
    char *txmsg = gdupl (__FILE__, __LINE__, string);
    char *p =  txmsg + strlen (txmsg);
    int tra_eol = 0;
    alarm (VXPOP_SENDTIMEOUT);
    /* Translate a UNIX or a MACintosh `end of line' into the sequence `\r\n' */
    if (*--p == '\r') {
	*p = '\0'; tra_eol = 1;
    } else if (*p == '\n') {
	if (*--p != '\r') { *++p = '\0'; tra_eol = 1; }
    }
    if (byte_stuff && *string == '.') {
	fprintf (stdout, ".%s", txmsg);
    } else {
	fprintf (stdout, "%s", txmsg);
    }
    if (tra_eol) { fprintf (stdout, "\r\n"); }
    fflush (stdout);
    alarm (0);
}

void pop_sline (char *string, int byte_stuff)
{
    char *p = string + strlen (string);
    pop_sstrg (string, byte_stuff);
    if (p[-1] != '\n' && p[-1] != '\r') {
	pop_sstrg ("\r\n", byte_stuff);
    }
}
