/* uf.h
**
** Interface file for uf.c
** (user folder file handling)
**
*/
#ifndef _UF_H
#define _UF_H

#include <stdio.h>

#include "dbif.h"
#include "xfile.h"

struct msg_s {
    ssize_t length, correction;
    int deleted;
};

#ifndef _UF_C

extern struct msg_s *const msgtbl;
extern xFile uf_folder;
extern const char *const foldername;

/* update an e-mail folder after closing the client connection */
extern void uf_update (void);

/* remove an index file in the case of a non-standard folder if the client
** broke the connection.
*/
extern void uf_abort (void);

/* initiate the folder access; in the case of a non-standard folder, this
** means: create an index file corresponding to the folder;
** after opening (and converting a non-standard folder) count the messages
** and calculate their sizes.
*/
extern int uf_setup (dbif_rec *rec);

/* call `xSeek (fx, ix)' and skip the standard `From ...'-line afterwards */
ssize_t From_Skip (xFile fx, int ix);

#endif /* defined (_UF_C) */

#endif /* defined (_UF_H) */
