/* userdb.c
**
** database handle for the user database
**
*/

#include "dbif.h"
#include "prefs.h"
#include "vxerror.h"

DBIF_FILE userdb = (DBIF_FILE) 0;

void userdb_init (void)
{
     if (!userdb) {
	 dbif_reset (&userdb, prefs.userdb_name);
	 if (!userdb) {
	     vxerror_at (EX_SOFTWARE, 0, __FILE__, __LINE__ - 2,
			 "connecting user database failed");
	 }
     }
}

void userdb_exit (void)
{
    if (userdb) {
	dbif_close (userdb);
	userdb = (DBIF_FILE) 0;
    }
}
