eval "exec perl $0 $*"
    if (running_from_any_shell);

use Cwd;

sub which ($);
sub cctest ($$);
sub runtest ($@);
sub ldstatic ($);
sub tolog (@);
sub ReadDBlist ();

($progname = $0) =~ s(.*/)();
($progpath = $0) =~ s(\Q$progname\E$)();
$progpath =~ s(/$)();
$progpath =~ s(^$|^\./|^([^/]))(cwd () . ($1 ? "/$1" : ""))e;
$filler = ' ' x (length $progname);
$logfile = sprintf "%s/%s.log", cwd (), $progname;
unlink $logfile if (-f $logfile);

if (@ARGV) {
    $_ = '--nonstatic';
    if (/^\Q$ARGV[0]\E/) {
	$nonstatic = "yes";
	print ">> Static linking tests disabled!\n";
	tolog ("## Testing for the static libraries disabled!");
    }
}

select STDOUT; $| = 1;

#$SIG{__DIE__} = sub { unlink $logfile; }

# Check if the zlib library exists on this system

$ZLIB = '';
$ZDEF = '';

%CFLAGS = ( 'cc' => '-O -g',
	    'gcc' => '-Wall -g -O2',
##	    'lcc' => '-g -A -D_POSIX_C_SOURCE=2 -D_BSD_SOURCE=1 ' .
	    'lcc' => '-g -A -D_POSIX_C_SOURCE=2 ' .
		     '-D_SVID_SOURCE=1 -D__inline__='
	  );

%LDFLAGS = ( 'cc' => '',
	     'gcc' => '-g',
	     'lcc' => '-g'
	   );

%RELINK = ( 'cc' => '-r',
	    'gcc' => '-r',
	    'lcc' => '-r'
	  );

%STATIC = ( 'cc' => '',
	    'gcc' => '-Wl,-static',
	    'lcc' => '-Wl-static'
	  );

%UNSTATIC = ( 'cc' => '',
	      'gcc' => '-Wl,-Bdynamic',
	      'lcc' => '-Wl-Bdynamic'
	    );

do {
    print ">> which C-compiler do you want to use [",
	  join (", ", (keys %CFLAGS)),
	  "]? ";
    $CC = <STDIN>; chomp $CC;
    unless (exists $CFLAGS{$CC}) {
	print STDERR "\nERROR! Please retry!\n";
    }
} until (exists $CFLAGS{$CC});

$CFLAGS = $CFLAGS{$CC};
$LDFLAGS = $LDFLAGS{$CC};
$RELINK = $RELINK{$CC};

## Omitting the frame pointer for the library - but only, if the compiler
## is the GNU C-compiler
$NOFP = ($CC eq 'gcc') ? "-fomit-frame-pointer" : "";

## Dump the version number into the file VERSION

($pp = $progpath) =~ s(.+/VxMail-([^/]+)(/.*|$))($1);
open VERSION, ">VERSION";
print VERSION "$pp\n";
close VERSION;

print ">> VxMail version = $pp\n";

## Save the $CFLAGS variable before the tests start

$CFLAGS_sav = $CFLAGS;
$CFLAGS .= ' -I.';

print ">> Compiling admin/typedef\n";

if (cctest (0, "typedef")) {
    die "$progname: Sorry, but i couldn't compile admin/typedef.c!\n",
	"$filler  +++ Configuration ABORTED! +++\n";
}

if (runtest (1, "./typedef", "-ovxtools/bittypes.h-1")) {
    die "$progname: Sorry, i couldn't create vxtools/bittypes.h-1\n",
	"$filler  +++ Configuration ABORTED! +++\n";
}
open IF, "<vxtools/bittypes.h-1";
open OF, ">vxtools/bittypes.h";
print OF '#ifndef __USE_BSD', "\n";
while (<IF>) {
    print OF $_;
}
print OF '#endif', "\n";
close IF;
close OF;
unlink "vxtools/bittypes.h-1";

print ">> is this a glibc-based system? ";

$OSTYPE=`uname -s`; chomp $OSTYPE;

tolog ("####### Testing if this is a gblic based system");
unless (cctest (0, "glibc-test")) {
    $LXLIBC5_WA = "/bin/true";
    if (runtest (1, "./glibc-test")) {
	$CFLAGS = "$CFLAGS -D_BSD_SOURCE=1";
	print "yes\n";
    } else {
	if ($OSTYPE eq 'Linux' and $CC ne 'gcc') {
	    $LXLIBC5_WA = "ln -sf lxlibc5 asm";
	}
	print "no\n";
    }
} else {
    die "$progname: Sorry, but compiling the `glibc-test' program failed!\n",
	"$filler  +++ Configuration ABORTED! +++\n";
}
#
print ">> CFLAGS = $CFLAGS\n\n";

print ">> library/linker flag for the `socket' system call? ";

if (cctest (1, "socket-test")) {
    $LDFLAGS_sav = $LDFLAGS;
    $LDFLAGS .= ' -lsocket';
    $LDFLAGS =~ s(^\s+)();
    if (cctest (1, "socket-test")) {
	die "$progname: Sorry, but i couldn't find the `socket' system call!\n",
	    "$filler  +++ Configuration ABORTED! +++\n";
    }
    $LDFLAGS = $LDFLAGS_sav;
    $SOCKLIB = '-lsocket';
    print "in `-lsocket'\n";
} else {
    print "in `-lc'\n";
}

print ">> library/linker flag for the `inet_ntoa' function? ";

if ($LXLIBC5_WA ne "/bin/true") {
    symlink 'vxtools/lxlibc5', 'asm';
}
if (cctest (1, "nsl-test")) {
    $LDFLAGS_sav = $LDFLAGS;
    $LDFLAGS = "$LDFLAGS -lnsl";
    $LDFLAGS =~ s(^\s+)();
    if (cctest (1, "nsl-test")) {
	unlink 'asm';
	die "$progname: Sorry, but i couldn't find the `inet_ntoa' library ",
	    "function!\n",
	    "$filler  +++ Configuration ABORTED! +++!\n";
    }
    $CFLAGS = $CFLAGS_sav;
    $LDFLAGS = $LDFLAGS_sav;
    $NSLLIB = "-lnsl";
    print "in `-lnsl'\n";
} else {
    print "in `-lc'\n";
}
unlink 'asm';

tolog
print ">> Is the `Dynamic Relay Authentication Control' library installed? ";
$LDFLAGS_sav = $LDFLAGS;
$LDFLAGS = "-ldrac $LDFLAGS";
if (cctest (1, "drac-test")) {
    print "no\n";
    $DRACDEF = '';
    $DRACLIB = '';
} else {
    print "yes\n";
    do {
	print ">> Do you want to compile DRAC-support into `VxMail'? ";
	$_ = <STDIN>; chomp; $ans = lc $_;
	if (length($ans) < 4 and $ans eq (substr "yes", 0, length $ans)) {
	    $ans = "yes";
	    $DRACDEF = '-DDRAC_AUTH';
	    $DRACLIB = '-ldrac';
	} elsif (length($ans) < 3 and $ans eq (substr "no", 0, length $ans)) {
	    $ans = "no";
	} else {
	    $ans = undef;
	}
	unless ($ans) { print "Please answer ONLY with `yes' or `no'!\n"; }
    } until ($ans);
}
$LDFLAGS = $LDFLAGS_sav;

print ">> Type of third argument of \`accept'? ";

$LDFLAGS_sav = $LDFLAGS;
$LDFLAGS = "$LDFLAGS $SOCKLIB $NSLLIB";
if (cctest (1, "szconv-test1")) {
    if (cctest (1, "szconv-test2")) {
	die "$progname: Sorry, but i couldn't find out the type for the\n",
	    "$filler  third argument of the \`accept' system call!\n",
	    "$filler  +++ Configuration ABORTED! +++\n";
    } else {
	$SZDEF = '-DSZCONV=\(int\ \*\)';
	print "(int *)\n";
    }
} else {
    $SZDEF = '-DSZCONV=';
    print "(unsigned int *)\n";
}

print ">> zlib exists? ";

tolog ("####### Testing the existance of the zlib library");
$LDFLAGS_sav = $LDFLAGS;
$LDFLAGS .=  ' -lz';
$LDFLAGS =~ s(^\s+)();
if (cctest (1, "zlib-test")) {
    print "no\n";
} else {
    tolog ("####### Testing if i can link -lz statically");
    $LDFLAGS = "$LDFLAGS_sav " . join (" ", ldstatic ('-lz'));
    $LDFLAGS =~ s(^\s+)();
    if ($nonstatic or cctest (1, "zlib-test")) {
	$ZLIB = '-lz';
	$ZDEF = '-DHAVE_ZLIB=1';
	print "yes\n";
    } else {
	$ZLIB = join (" ", ldstatic ("-lz"));
	$ZDEF = '-DHAVE_ZLIB=1';
	print "yes\n";
    }
}
$LDFLAGS = $LDFLAGS_sav;

# Check if the crypt function is part of the `libc' or if an additional
# library (`libcrypt') must be included

$CRYPTLIB = '';
$CRYPTDEF = '';

print ">> `crypt' in libcrypt? ";

tolog ("####### Testing if `crypt' is in the standard C library");
if (cctest (1, "crypt-test0")) {
    tolog ("####### Testing if `crypt' is in the `libcrypt' library");
    $LDFLAGS_sav = $LDFLAGS;
    $LDFLAGS .= ' -lcrypt';
    $LDFLAGS =~ s(^\s+)();
    if (cctest (1, "crypt-test1")) {
	die "$progname: Sorry, but i could find `crypt' neither in the libc\n",
	    "$filler  library nor in the library `libcrypt'!\n",
	    "$filler  +++ Configuration ABORTED! +++\n";
    }
    $CRYPTLIB = '-lcrypt';
    $CRYPTDEF = '-DNEED_CRYPT_H=1';
    $LDFLAGS = $LDFLAGS_sav;
    print "yes\n";
} else {
    print "no\n";
}

# Check if we have to use sysv_signal (Linux only) instead of signal

##
$_ = `uname -s`; chomp;
if (/^Linux$/) {
    print ">> is the signal style SYSV or BSD? ";
    tolog ("####### Testing if default `signal' is SYSV or BSD style");
    if (cctest (0, "signal-test")) {
	die "$progname: Sorry, but the signal test failed!\n",
	    "$filler  +++ Configuration ABORTED! +++\n";
    }
    if (runtest (1, "./signal-test")) {
	$SIGDEF = '-Dsignal=sysv_signal';
	print "BSD -- re-defining \`signal' as `sysv_signal'\n";
    } else {
	print "SYSV\n";
    }
}
##

# Check if one of the different database libraries exists

# Read the already configured database types
#
ReadDBlist ();

$CGLAGS = $CFLAGS_sav;
$LDFLAGS_sav = $LDFLAGS;

$CFLAGS_sav = $CFLAGS;
for $dl (@DBLIBS) {
    $LDFLAGS = $LDFLAGS_sav;
    $LDFLAGS .= " $DBLIBS{$dl}";
    $LDFLAGS =~ s(^\s+)();
    $CFLAGS = "$CFLAGS_sav $DBDEFS{$dl}";
    tolog ("####### Testing if the $dl database library exists");
    if (cctest (1, $DBTEST{$dl})) {
	delete $DBTEST{$dl};
	delete $DBDEFS{$dl};
	delete $DBLIBS{$dl};
	delete $DBDIRS{$dl};
    }
}
$LDFLAGS = $LDFLAGS_sav;
$CFLAGS = $CFLAGS_sav;

if (exists $DBTEST{'DB2'}) {
    $DBTEST{'DB1'} = $DBTEST{'DB2'};
    $DBLIBS{'DB1'} = $DBLIBS{'DB2'};
    ($DBDIRS{'DB1'} = $DBDIRS{'DB2'}) =~ s(DB2)(DB1);
    $DBDEFS{'DB1'} = '-DLIBDB=2';
}

unless ((keys %DBTEST)) {
    die "$progname: Sorry, but your system doesn't support any of the",
	"$filler  database libraries \`VxMail' is configured for!\n",
	"$filler  +++ Configuration ABORTED! +++\n";
}

$dl = (keys %DBTEST)[0];
$DBDIR  = $DBDIRS{$dl};
$DBLIB  = $DBLIBS{$dl};
$DBDEF  = $DBDEFS{$dl};
$DBTEST = $DBTEST{$dl};
$DBTYPE = $dl;

if ((keys %DBTEST) > 1) {
    do {
	print ">> Which type of database should \`VxMail' use [",
	      join (" | ", (keys %DBTEST)),
	      "]? ";
	$dl = <STDIN>; chomp $dl;
	$dl = uc ($dl);
	unless (exists $DBTEST{$dl}) {
	    print "\n## INVALID; Please retry! ##\n";
	}
    } until (exists $DBTEST{$dl});
    $DBDIR  = $DBDIRS{$dl};
    $DBLIB  = $DBLIBS{$dl};
    $DBDEF  = $DBDEFS{$dl};
    $DBTEST = $DBTEST{$dl};
    $DBTYPE = $dl;
}

## With the next step i decide if the database library is included statically
unless ($nonstatic) {
    tolog ("####### Testing if i can link $DBLIB statically");
    $LDFLAGS_sav = $LDFLAGS;
    $LDFLAGS .= " " . join (" ", ldstatic ($DBLIB));
    $LDFLAGS =~ s(^\s+)();
    unless (cctest (1, $DBTEST)) {
    #    $DBLIB = join (' ', ldstatic ($DBLIB));
	$DBLIB = "-static $DBLIB";
    }

    $LDFLAGS = $LDFLAGS_sav;
    $CFLAGS = $CFLAGS_sav;
}

for $dir (@ARGV) {
    print ">> Creating $dir/Makefile ";
    open PROTO, "<$dir/Makefile.proto" or die "$progname failed: $!\n";
    open MAKEF, ">$dir/Makefile" or die "$progname failed: $!\n";
    while (<PROTO>) {
	s(\%CC%)($CC);
	s(\%CFLAGS\%)($CFLAGS);
	s(\%LDFLAGS\%)($LDFLAGS);
	s(\%ZLIB\%)($ZLIB);
	s(\%ZDEF\%)($ZDEF);
	s(\%CRYPTLIB\%)($CRYPTLIB);
	s(\%CRYPTDEF\%)($CRYPTDEF);
	s(\%SIGDEF\%)($SIGDEF);
	s(\%DBDEF\%)($DBDEF);
	s(\%DBLIB\%)($DBLIB);
	s(\%DBDIR\%)($DBDIR);
	s(\%DBTYPE\%)($DBTYPE);
	s(\%LXLIBC5_WA\%)($LXLIBC5_WA);
	s(\%NOFP\%)($NOFP);
	s(\%SOCKLIB\%)($SOCKLIB);
	s(\%NSLLIB\%)($NSLLIB);
	s(\%RELINK\%)($RELINK);
	s(\%SZDEF\%)($SZDEF);
	s(\%DRACDEF\%)($DRACDEF);
	s(\%DRACLIB\%)($DRACLIB);
	print MAKEF $_;
    }
    close MAKEF;
    close PROTO;
    print "done.\n";
}

exit 0;
####### End of main program

## Search for excutable plain files (probably programs)

sub which ($) {
    my ($prog) = @_;
    my (@PATH) = split /:/, $ENV{'PATH'};
    my ($el);
    for $el (@PATH) {
	if ((-f "$el/$prog") and (-x "$el/$prog")) {
	    return "$el/$prog";
	}
    }
    return undef;
}

## Do the C-test

## try to compile a file using the selected C-compiler; if this succeeds,
## delete the resulting output file if the first argument of this function
## is true.
sub cctest ($$) {
    my ($delflg, $file) = @_;
    my @CF = split /\s+/, $CFLAGS;
    my @LF = split /\s+/, $LDFLAGS;
    open SAVERR, ">&STDERR";
    open STDERR, ">>$logfile";
    select STDERR; $| = 1;
    print STDERR "### Command: $CC ", join(" ", @CF), " -o$file admin/$file.c ",
		 join(" ", @LF), "\n";
    $res = system $CC, @CF, "-o$file", "admin/$file.c", @LF;
    open STDERR, ">&SAVERR";
    close SAVERR;
    unless ($res) {
	unlink "$file" if ($delflg);
    }
    $res
}

## try to run a compiled program; delete the program file thereafter
## if the first argument of this function is true
sub runtest ($@) {
    my $delflg = (shift @_);
    my ($res);
    open SAVERR, ">&STDERR";
    open STDERR, ">>$logfile";
    select STDERR; $| = 1;
    print "### Running: ", join(" ", @_), "\n";
    $res = system @_;
    open STDERR, ">&SAVERR";
    close SAVERR;
    if ($delflg) {
	unlink $_[0];
    }
    $res;
}

sub ldstatic ($) {
    if ($STATIC{$CC}) {
	$STATIC{$CC}, $_[0], $UNSTATIC{$CC}
    } else {
	$_[0]
    }
}

sub tolog (@) {
    open LOG, ">>$logfile";
    print LOG join ("\n", (map { ($x = $_) =~ s(%s)(sutest)g; $x } @_)), "\n";
    close LOG;
}

sub ReadDBlist () {
    my $DBlist = "$progpath/DBlist";
    open DBLIST, "<$DBlist" or
	die "$progname: Sorry, but i couldn't open the file \`$DBlist'!\n",
	    "$filler  $!\n",
	    "$filler  +++ Configuration ABORTED! +++\n";
    @DBLIBS = ();
    %DBTEST = ();
    %DBDEFS = ();
    %DBLIBS = ();
    %DBDIRS = ();
    while (<DBLIST>) {
	next if (/^\s*#|^\s*$/);
	($id, $prog, $cppopts, $ldopts, $dbifdir) = split ':', $_;
	#DB2:db2-test:-DLIBDB=2:-ldb2:dbif/DB2
	push @DBLIBS, $id;
	$DBTEST{$id} = $prog;
	$DBDEFS{$id} = $cppopts;
	$DBLIBS{$id} = $ldopts;
	$DBDIRS{$id} = $dbifdir;
    }
    close DBLIST;
    unless (@DBLIBS) {
	die "$progname: Sorry, but there are no database types configured!\n",
	    "$filler  +++ Configurationn ABORTED! +++\n";
    }
}
