#! /bin/sh

if [ $# -lt 2 ]; then
    echo "${0##*/}: No input file supplied - no database created!"
    exit 0
fi
echo "$PATH"
# Create an initial user database and the corresponding directories
vxuser="`vxgetconf -f $1 vxuser`"
vxgroup="`vxgetconf -f $1 vxgroup`"
userdb="`vxgetconf -f $1 userdb`"

dbdir="`expr $userdb : '\(.*\)/[^/]*'`"
dbname="`expr $userdb : '.*/\([^/]*\)'`"

cat >initdb.conf.$$ <<EOT
userdb ${DESTDIR}${userdb}
vxuser ${vxuser}
vxgroup ${vxgroup}
EOT

mkdir -p "${DESTDIR}${dbdir}"
chown $vxuser "${DESTDIR}${dbdir}"
chgrp $vxgroup "${DESTDIR}${dbdir}"
chmod ug+s "${DESTDIR}${dbdir}"
bin/vxmkdb -f initdb.conf.$$ "$2" | \
    sed -e "s|^[^ ]* \(.*\)|mkdir -p ${DESTDIR}\1; chown $vxuser ${DESTDIR}\1; \
	    chgrp $vxgroup ${DESTDIR}\1|" \
	>initdb.sh.$$
chown $vxuser "${DESTDIR}${userdb}"
chgrp $vxgroup "${DESTDIR}${userdb}"
/bin/sh initdb.sh.$$
rm -f initdb.sh.$$
rm -f initdb.conf.$$
