# This is my spec file for RPM based distributions
#
Name: VxMail
Version: 1.39
Release: 1
Copyright: GPL for the package, LGPL for the library `libvxtools.a', examples free
Group: Mail
Source: VxMail-1.39.tgz
Summary: Local delivery agent and POP3 server for implementing virtual mail domains
BuildRoot: /tmp/VxMail
%description
VxMail is a local delivery sub-system and POP3 service which enables holding
more than one e-mail domain on one host. At the moment this package consists of
the programs
    `vxcheck'		- checks folder for limits in age and/or size of
			  messages
    `vxconv' 		- convert smail/sendmail folders into the format
			  required by VxMail
    `vxdeliver'		- deliver mails locally; this program uses the
			  complete recipient address as an index into a user
			  database (GDBM at the moment); this will make this
			  system independant from the system's password
			  database and allows you to hold more than one mail
    `vxdomcheck'	- check if a name supplied as argument corresponds to
			  a domain entry in the user database
    `vxdump'		- dumps the user database in a format directly
			  readable by `vxmkdb'
    `vxgetconf'		- write the complete configuration of the VxMail system
			  or a single configuration item of it to stdout; you
			  can also find out the compiled configuration defaults
			  by using this tool
    `vxmkdb'		- create the user database from a human readable
			  description
    `vxpop'		- the POP3 server of the VxMail system which can
			  handle smail/sendmail folders, too.

%package dev
Group: Mail
Summary: The library and header files
%description dev
Library and header files for further VxMail development.

%prep
%setup

%build
make PREFIX=/usr

%install
strip dist/bin/*
if which fakeroot >/dev/null 2>&1; then
    fakeroot make DESTDIR="$RPM_BUILD_ROOT" PREFIX=/usr install.de
else
    su -c "make DESTDIR=\"$RPM_BUILD_ROOT\" PREFIX=/usr install.de"
fi

%files
%doc AUTHORS
%doc Copyright
%doc examples
%config /etc/vxmail.conf
%config /etc/vxmail-redir.txt

/usr/sbin/vxcheck
/usr/sbin/vxconv
/usr/sbin/vxdeliver
/usr/sbin/vxwrapper
/usr/sbin/vxdomcheck
/usr/sbin/vxdump
/usr/sbin/vxgetconf
/usr/sbin/vxmkdb
/usr/sbin/vxpop
/usr/man/de/man8/vxcheck.8.gz
/usr/man/de/man8/vxconv.8.gz
/usr/man/de/man8/vxdeliver.8.gz
/usr/man/de/man8/vxdomcheck.8.gz
/usr/man/de/man8/vxdump.8.gz
/usr/man/de/man8/vxgetconf.8.gz
/usr/man/de/man8/vxmkdb.8.gz
/usr/man/de/man8/vxpop.8.gz

%files dev
/usr/lib/libvxtools.a
/usr/include/vx/bittypes.h
/usr/include/vx/conf.h
/usr/include/vx/config.h
/usr/include/vx/conv.h
/usr/include/vx/dbif.h
/usr/include/vx/exitcodes.h
/usr/include/vx/hlsock.h
/usr/include/vx/md5.h
/usr/include/vx/prefs.h
/usr/include/vx/rc4.h
/usr/include/vx/regex.h
/usr/include/vx/rfc822.h
/usr/include/vx/sysauth.h
/usr/include/vx/tools.h
/usr/include/vx/utypes.h
/usr/include/vx/version.h
/usr/include/vx/vxerror.h
/usr/include/vx/vxopt.h
/usr/include/vx/xfile.h

%post
#! /bin/sh

# Create the group `mail' if it does not already exist
if ! grep -q '^mail:' /etc/group; then
    groupadd -g 8 mail
fi

# Create the user `mail' if it does not already exist
if ! grep -q '^mail:' /etc/passwd; then
    useradd -c "mail system user" -d /var/spool/mail -g mail -s /bin/false \
            -u 8 mail
    chown mail.mail /var/spool/mail
    chmod a+rwx,+t /var/spool/mail
fi

chown root.mail /usr/sbin/vxwrapper
chmod 4510 /usr/sbin/vxwrapper

%clean
rm -rf "$RPM_BUILD_ROOT"
