#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>

#include "config.h"
#include "prefs.h"
#include "vxerror.h"
#include "conf.h"

int main (int argc, char *argv[])
{
    progname = strrchr (argv[0], '/');
    if (progname) ++progname; else progname = argv[0];
    if (argc < 2) {
	fprintf (stderr, "Usage: %s conffile\n", argv[0]);
	exit (1);
    }
    prefs.config_name = argv[1];
    getconf ();
    printf ("prefs.config_name = \"%s\"\n", prefs.config_name);
    printf ("prefs.userdb_name = \"%s\"\n", prefs.userdb_name);
    printf ("prefs.service = \"%s\"\n", prefs.service);
    printf ("prefs.errors = %s\n",
	    (prefs.errors == ERRORS_ADMIN ? "admin" : "system"));
    printf ("prefs.fperm = %o\n", prefs.fperm);
    printf ("prefs.biirm = %s\n", (prefs.biirm ? "yes" : "no"));
    printf ("prefs.maxclients = %d\n", prefs.maxclients);
    printf ("prefs.vxuid = %d\n", prefs.vxuid);
    printf ("prefs.vxgid = %d\n", prefs.vxgid);
    printf ("prefs.msg_firstline = \"%s\"\n", prefs.msg_firstline);
    printf ("prefs.msg_lastline = \"%s\"\n", prefs.msg_lastline);
    printf ("prefs.sysauth = %s\n", (prefs.sysauth ? "yes" : "no"));
    return 0;
}
