/* dbif_priv.h
**
** PRIVATE Database Interface for the user/admin databases
*/
#ifndef _DBIF_PRIV_H
#define _DBIF_PRIV_H

#if LIBDB == 2
#include <db2/db_185.h>
#else
#include <db.h>
#endif

#include "dbif.h"
#include "xfile.h"

struct _DBIF_FILE_S {
    DB *dbf;
    DBT current;
    int rw;
};

struct _DBIF_CURSOR_S {
    char *res_name;	/* the filename of the results file		   */
    xFile results;	/* the file holding the results			   */
    char *buf;		/* a buffer which is large enough to hold the largest
			** record of the selection			   */
    size_t bufsize;	/* the size of the buffer			   */
    int recno;
};

dbif_rec *dbif_mkreca (char *p);

static __inline__ void set_int (unsigned char *res, int iv)
{
    unsigned char *p = res + sizeof (int);
    while (p != res) {
	*--p = (unsigned char) (iv & 0xff);
	iv >>= 8;
    }
}

static __inline__ int get_int (unsigned char *iv)
{
    int ix, res = 0;
    for (ix = 0; ix < sizeof (int); ++ix) {
	res <<= 8;
	res |= (int) *iv++;
    }
    return res;
}

#endif /* defined(_DBIF_PRIV_H) */
