/* exithl.h
**
** Interface file for `exithl.c'
** (REMOVABLE exit functions (based on a handler which is automatically
**  installed with `atexit' when the first exit handler is installed).)
*/
#ifndef _EXITHL_H
#define _EXITHL_H

/* add_exithl (name, exit_func)
**     inserts the function `exit_func' with the handle-name `name' at the
**     top of the `handler_list' and installs the function `exit_handler'
**     with `atexit' if it is not already installed.
*/
void add_exithl (char *handle_name, void (*exit_func) (void));

/* del_exithl (name)
**     removes each occurrence of the exit handler with the handle-name `name'
**     from the `handler_list'.
*/
void del_exithl (char *handle_name);

/* clean_exithl ()
**     removes all exit handlers from the `handler_list'
*/
void clean_exithl (void);

#endif /* defined(_EXITHL_H) */
