/* gz.c
**
** a LZ77 compression/decompression filter based on the `zlib' library and
** zhe `xfile' module (part of `libshtools.a' in VxMail)
**
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <zconf.h>
#include <zlib.h>

#include "prefs.h"
#include "vxerror.h"
#include "xfile.h"
#include "tools.h"


struct _gz_s {
    int input;
    z_stream s;
    xFile fx;
    char *ionb, *outb;
};

gzFilter gzOpen (xFile fx, int input, int level)
{
    gzFilter gzf = galloc (__FILE__, __LINE__, sizeof (_gz_s));
    char *p = (char *) gzf + sizeof (_gz_s);
    gzf->inb = p;
    gzf->outb = p + ibsz;
    gzf->fx = fx;
    gzf->input = input;
    if (input) {
	gzf->s.next_in = gzf->inb = NULL;
	gzf->s.avail_in = 0;
	gzf->s.zalloc = (alloc_func) 0;
	gzf->s.zfree = (free_func) 0;
	gzf->s.opaque = (voidpf) 0;
	if (inflateInit (&(gzf->s)) != Z_OK) {
	    gfree (gzf);
	    return (gzFilter) 0;
	}
    } else {
	gzf
