/* mksinetab.c
**
** create a table of 4294967296 * abs (sin (i)) (i = 1, ..., 64) on stdout
** as a C language construct
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

static char *progname;

int main (int argc, char *argv[])
{
    int ix;
    unsigned long isin;
    double rsin;

    progname = strrchr (argv[0], '/');
    if (progname) ++progname; else progname = argv[0];

    printf("/* Automatically generated from %s; DO NOT MODIFY! */\n", progname);
    printf("\n\n");
    printf("static unsigned long %s[64] = {", (argc > 1 ? argv[1] : "T"));
    for (ix = 1; ix <= 64; ++ix) {
	rsin = 4294967296.0 * fabs (sin ((double) ix));
	isin = (unsigned long) rsin;
	if (ix == 1) {
	    printf ("\n    ");
	} else if ((ix - 1) % 4 == 0) {
	    printf (",\n    ");
	} else {
	    printf (", ");
	}
	printf("0x%.8lx", isin);
    }
    printf ("\n};\n");
    fflush (stdout);
    return 0;
}
