/* prefs.h
**
** Interface file for `prefs.c'
** (Preferences)
*/
#ifndef _PREFS_H
#define _PREFS_H

#include <unistd.h>
#include <sys/types.h>

#include "config.h"

#define ERRORS_ADMIN 1
#define ERRORS_SYSTEM 0
#define ERRORS_ALL 2

struct preferences {
    char *config_name;
    char *userdb_name;
    char *listdir;
    char *nonlocalto;
    char *service;
    char *msg_firstline;
    char *msg_lastline;
    char *qmbox;
    char *redir_info;
    int errors;
    int fperm;
    int biirm;
    int maxclients;
    uid_t vxuid;
    gid_t vxgid;
    int sysauth;
    long check_size;
    int check_days;
    int dsizecheck;
    int compression;
    int dbtype;
    int msg_scantype;
    int lcuser;
    int lcdomain;
    int syswithidx;
    int maxlevel;
    int rejverb;
    int dracauth;
    int bsmtp_nodomain;
};

#ifndef _PREFS_C
extern struct preferences prefs;

extern char *progname;

extern int loglevel;
#endif /* defined(_PREFS_C) */

#endif /* defined(_PREFS_H) */
