/* rc4.c
**
** RC4 encryption module based on an article in the german `Linux Magazin'
** Nov. 1997, written by Oliver Mller.
**
*/

void rc4_init (unsigned char *key, unsigned char *sbox)
{
    unsigned ix, jx;
    unsigned char *kptr = key, trans, k[256];
    for (ix = 0; ix < 256; ++ix) {
	sbox[ix] = (unsigned char) ix;
    }
    for (ix = 0; ix < 256; ++ix) {
	k[ix] = *kptr++;
	if (!*kptr) kptr = key;
    }
    for (ix = 0, jx = 0; ix < 256; ++ix) {
	jx = (jx + sbox[ix] + k[ix]) % 256;
	trans = sbox[ix];
	sbox[ix] = sbox[jx];
	sbox[jx] = trans;
    }
}

void rc4_encrypt (unsigned char *s, int ll, unsigned char *sbox)
{
    unsigned int ix, jx, tx;
    unsigned char trans;
    for (ix = 0, jx = 0; ll; --ll, ++s) {
	ix = (ix + 1) % 256;
	jx = (jx + sbox[ix]) % 256;
	trans = sbox[ix];
	sbox[ix] = sbox[jx];
	sbox[jx] = trans;
	tx = (sbox[ix] + sbox[jx]) % 256;
	*s ^= sbox[tx];
    }
}
