#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>

#include "rfc822.h"

int main (int argc, char *argv[]) {
    char rfc822[1024];
    time_t utc;
    int p;
    char *q;
    if (argc < 2) {
	fprintf (stderr, "%s: missing argument!\n", argv[0]);
	return 1;
    }
    if (argc == 2) {
	strncpy (rfc822, argv[1], 1023);
	if (strlen (argv[1]) > 1023) { rfc822[1023] = '\0'; }
    } else if (argc >= 7) {
	if (argc == 7) {
	    sprintf (rfc822, "%s %s %s %s %s %s", argv[1], argv[2], argv[3],
						  argv[4], argv[5], argv[6]);
	} else {
	    sprintf (rfc822, "%s %s %s %s %s %s %s", argv[1], argv[2], argv[3],
						     argv[4], argv[5], argv[6],
						     argv[7]);
	}
    }
    if ((p = rfc822_time (rfc822, &utc))) {
	fprintf (stderr, "%s: conversion failed!\n", argv[0]);
	while ((q = strchr (rfc822, '\t'))) { *q = ' '; }
	fprintf (stderr, "%s\n", rfc822);
	while (--p > 0) { putc (' ', stderr); }
	fprintf (stderr, "^\n");
	return 1;
    }
    printf ("The resulting time value is: %ld\n", utc);
    return 0;
}
