/* tools.h
**
** Interface for file `tools.c'
** (Einige ntzliche Routinen)
*/
#ifndef _TOOLS_H
#define _TOOLS_H

#include <stdio.h>
#include <pwd.h>
#include <sys/types.h>
#include <time.h>
#include <stdarg.h>

typedef void (*exception_t) (char *msg);

#ifndef _TOOLS_C

exception_t setup_exception (exception_t handle);

void heap_init (void);

char *sdupl (char *string);

char *gdupl (char *file, int line, char *string);

void *galloc (char *file, int line, size_t size);

void gfree (void *ref);

void *gresize (char *file, int line, void *ref, size_t size);

/* concat a NULL-terminated list of string to a new string which is the
** result of this function.
*/
char *vconcat (char *_1st, char **ap);
char *concat (char *_1st, ...);
char *gconc (char *file, int line, ...);

void vxlog (int ll, char *fmt, ...);

void npfxlog (char *fmt, ...);

void vvxlog (int ll, char *fmt, va_list av);

int lccmp (char *s1, char *s2, size_t n);

void lcconv(char *bf, int bfl);

#endif /* defined(_TOOLS_C) */

#endif /* defined(_TOOLS_H) */
