/* vxerror.c
**
** Fehlerausgaben und Programmabbruch
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <stdarg.h>
#include <limits.h>

#include "prefs.h"
#include "exitcodes.h"

void vxerror_at (int excode, int errcode, char *file, int line, char *fmt, ...)
{
    va_list argp;
    va_start (argp, fmt);
    fprintf (stderr, "%s(%d): ", file, line);
    vfprintf (stderr, fmt, argp);
    va_end (ap);
    if (errcode) {
	fprintf (stderr, ": %s\n", strerror (errcode));
    }
    if (excode) {
	exit (excode);
    }
}

void vxerror (int excode, int errcode, char *fmt, ...)
{
    va_list argp;
    va_start (argp, fmt);
    fprintf (stderr, "%s: ", progname);
    vfprintf (stderr, fmt, argp);
    va_end (ap);
    if (errcode) {
	fprintf (stderr, ": %s\n", strerror (errcode));
    }
    if (excode) {
	exit (excode);
    }
}
