/* xfile.h
**
** Interface file for xfile.c
** (Handle folder files with index files)
**
*/
#ifndef _XFILE_H
#define _XFILE_H
struct __xFile;

typedef struct __xFile *xFile;

#ifndef _XFILE_C
#define _XFILE_C

/*#include <stdio.h>*/
#include <unistd.h>
#include <sys/types.h>

extern void xSetBufSize (size_t siz);

extern xFile xOpen (char *path, char *amode, ...);

extern int xSeek (xFile fx, off_t index);

extern ssize_t xFlush (xFile fx);

extern ssize_t xWrite (xFile fx, void *buf, size_t bfs);

extern ssize_t xRead (xFile fx, void *buf, size_t bfs);

ssize_t xMsgLen (xFile fx, int pos);

extern int xSet (xFile fx, ...);

extern int xReSet (xFile fx);

extern int xClose (xFile fx);

extern ssize_t xPuts (char *buf, xFile fx);

extern int xGetc (xFile fx);

extern ssize_t xGets (char *buf, size_t siz, xFile fx);

extern int xPutc (int cc, xFile fx);

extern int xUnlink (char *file);

extern int xNoIndex (char *file);

int xEmpty (xFile fx);

int xChown (xFile fs, uid_t uid, gid_t gid);

#endif /* defined(_XFILE_C) */

#endif /* defined(_XFILE_H) */
