#include <stdio.h>
#include "xfile.h"

static char msg1[] = "This is example 1 ....... short\n";
static char msg2[] = "example 2 ... very short\n";
static char msg3[] = "This is example 3 .... long\n"
		     "with more than one line!\n"
		     "dupe, dupe, dupe, dupe, ...\n";
static char msg4[] = "This is example 4 .... very long!\n"
		     "many, many lines +..........\n"
		     "many, many lines .+.........\n"
		     "many, many lines ..+........\n"
		     "many, many lines ...+.......\n"
		     "many, many lines ....+......\n"
		     "many, many lines .....+.....\n"
		     "many, many lines ......+....\n"
		     "many, many lines .......+...\n"
		     "many, many lines ........+..\n"
		     "many, many lines .........+.\n"
		     "many, many lines ..........+\n"
		     "many, many lines *..........\n"
		     "many, many lines .*.........\n"
		     "many, many lines ..*........\n"
		     "many, many lines ...*.......\n"
		     "many, many lines ....*......\n"
		     "many, many lines .....*.....\n"
		     "many, many lines ......*....\n"
		     "many, many lines .......*...\n"
		     "many, many lines ........*..\n"
		     "many, many lines .........*.\n"
		     "many, many lines ..........*\n"
		     "many, many lines :..........\n"
		     "many, many lines .:.........\n"
		     "many, many lines ..:........\n"
		     "many, many lines ...:.......\n"
		     "many, many lines ....:......\n"
		     "many, many lines .....:.....\n"
		     "many, many lines ......:....\n"
		     "many, many lines .......:...\n"
		     "many, many lines ........:..\n"
		     "many, many lines .........:.\n"
		     "many, many lines ..........:\n"
		     "many, many lines $..........\n"
		     "many, many lines .$.........\n"
		     "many, many lines ..$........\n"
		     "many, many lines ...$.......\n"
		     "many, many lines ....$......\n"
		     "many, many lines .....$.....\n"
		     "many, many lines ......$....\n"
		     "many, many lines .......$...\n"
		     "many, many lines ........$..\n"
		     "many, many lines .........$.\n"
		     "many, many lines ..........$\n"
		     "many, many lines %..........\n"
		     "many, many lines .%.........\n"
		     "many, many lines ..%........\n"
		     "many, many lines ...%.......\n"
		     "many, many lines ....%......\n"
		     "many, many lines .....%.....\n"
		     "many, many lines ......%....\n";

static char *msgs[] = {
    msg1,
    msg2,
    msg3,
    msg4,
    NULL
};

int main (int argc, char *argv[])
{
    int ix, rl;
    xFile fx;
    char *fn = (argc < 2 ? "xftestfile" : argv[1]), buf[10];
    ssize_t msglen;
    xSetBufSize (128);
    printf ("Opening file `%s' ...", fn); fflush (stdout);
    if (!(fx = xOpen (fn, "w", 0600))) {
	printf (" failed!\n");
	exit (1);
    } else {
	printf (" succeeded!\n");
    }
    for (ix = 0; msgs[ix]; ++ix) {
	printf ("Writing `%s' to `%s' ...", msgs[ix], fn); fflush (stdout);
	if (xWrite (fx, msgs[ix], strlen (msgs[ix])) < 0) {
	    printf (" failed!\n");
	    xClose (fx);
	    exit (1);
	} else {
	    printf (" succeeded!\n");
	}
	printf ("Setting Mark for `%s' in Indexfile `%s.idx' ...",
		msgs[ix],
		fn);
	fflush (stdout);
	if (xSet (fx) < 0) {
	    printf (" failed!\n");
	    xClose (fx);
	    exit (1);
	} else {
	    printf (" succeeded!\n");
	}
    }
    printf ("Closing file `%s' ...", fn); fflush (stdout);
    if (xClose (fx) < 0) {
	printf (" failed!\n");
	xClose (fx);
	exit (1);
    } else {
	printf (" succeeded!\n");
    }
    printf ("\n\nOpening file `%s' for reading ...", fn); fflush (stdout);
    if (!(fx = xOpen (fn, "r"))) {
	printf (" failed!\n");
	exit (1);
    } else {
	printf (" succeeded!\n");
    }
    ix = 2;
    printf ("Positioning to message %d in file `%s' ...", ix, fn);
    fflush (stdout);
    if ((rl = xSeek (fx, ix)) < 0) {
	printf (" failed (%d)!\n", rl);
	xClose (fx);
	exit (1);
    } else {
	printf (" succeeded!\n");
    }
    printf ("Reading message %d from file `%s' ... >>", ix, fn);
    fflush (stdout);
    ix = 0;
    for (ix = 0; (msglen = xMsgLen (fx, ix)) >= 0; ++ix) {
	printf ("Message %d has a size of %ld\n", ix, msglen);
    }
/*    while ((rl = xRead (fx, buf, 9)) > 0) {*/
    while ((rl = xGets (buf, 9, fx)) > 0) {
	printf ("%s", buf); fflush (stdout);
    }
/*    while ((rl = xGetc (fx)) >= 0) {
	putc (rl, stdout);
    }
*/
    printf ("<<\n");
    printf ("Closing file `%s' ...", fn); fflush (stdout);
    if (xClose (fx) < 0) {
	printf (" failed!\n");
	xClose (fx);
    } else {
	printf (" succeeded!\n");
    }
    printf ("\n\n+++++++++++++++ "
	    "Operations done and successful! "
	    "+++++++++++++++\n\n");
    return 0;
}
